#include "sLCD.h"
#include "SonyIR.h"
#include "Binary.h"
// Hero_IR_Remote.c
// This Program is meant to Remotely Control the Heathkit Hero I Robot.
// The circuit is used in place of the Hand Teaching Pendant.
// A 20X4 LCD is used for monitoring,  but is not necessary to control
// the Robot.  A Sony IR Remote set for DVD Mode, is used as the Transmitter.
// A speaker output confirms code received.
// The key codes are below.
// Make sure to set IR Port in SonyIR.h Routine!!!!
/*
Sony IR Keys to Decimal: Set for Sony DVD
*** IF HEAD = 0: ***
North/UP = 121       MOTOR FORWARD
South/DN = 122       MOTOR REVERSE
West/Left = 123      MOTOR LEFT
East/Right = 124     MOTOR RIGHT
Center/Sel = 11      STOP
Prev CH  = 059       N/A
*** IF HEAD = 1: ***
North/UP = 131       ARM PIVOT RAISE
South/DN = 132       ARM PIVOT LOWER
West/Left = 133      HEAD LEFT
East/Right = 134     HEAD RIGHT
#1 = 10              N/A
#2 = 11              STOP
#3 = 12              WRIST PIVOT R
#4 = 13              GRIPPER OPEN
#5 = 14              WRIST PIVOT L
#6 = 15              GRIPPER CLOSE
#7 = 16              WRIST ROTATE L
#8 = 17              N/A
#9 = 18              WRIST ROTATE R
#0 = 19              N/A
CH UP = 59           ARM EXTEND
CH DN = 58           ARM RETRACT
POWER = 21           HEAD/BODY MODE TOGGLE


NOTE:  THIS APPLICATION USES THE PIC16F688 @ 8Mhz
PORTA is used to drive the 74174.
+5V  PIN 3  Teaching Pendant
Gnd  PIN 15 Teaching Pendant
RA0, PIN 13 is IR Detector Input
RA1, PIN 13 Teaching Pendant
RC0, PIN 9 Teaching Pendant
RC1, PIN 1 Teaching Pendant
RC2, PIN 2 Teaching Pendant
RC3, PIN 8 Teaching Pendant
RC4, PIN 14 Teaching Pendant
RC5, PIN 7 Teaching Pendant
IR Code by Andrew Kilpatrick
Modified by
RC Irace
4.16.2009
*/
//***************************************************************************
//Variable Declarations
//***************************************************************************
//                          1234567890123456
const char Message1[17]  = "HERO 1 IR Demo  ";
const char Message2[17]  = "P16F688         ";
const char Message3[17]  = "Motor Forward   ";
const char Message4[17]  = "Motor Left      ";
const char Message5[17]  = "Motor Right     ";
const char Message6[17]  = "Head Right      ";
const char Message7[17]  = "Head Left       ";
const char Message8[17]  = "Arm Raise       ";
const char Message9[17]  = "Arm Lower       ";
const char Message10[17] = "Arm Extend      ";
const char Message11[17] = "Arm Retract     ";
const char Message12[17] = "Grip Open       ";
const char Message13[17] = "Grip Close      ";
const char Message14[17] = "Wrist Pivot L   ";
const char Message15[17] = "Wrist Pivot R   ";
const char Message16[17] = "Wrist Rotate L  ";
const char Message17[17] = "Wrist Rotate R  ";
const char Message18[17] = "Motor Reverse   ";
const char Message19[17] = "IR Code         ";
const char Message20[17] = "                ";
const char Message21[17] = "Stop            ";
const char Message22[17] = "Head Mode       ";
char Dlay = 0;
char Temp = 0;
char Cycles = 0;
char IRCode = 0;
unsigned char sony_cmd;
unsigned short *port;
//****************************************************************************
void Delay500ms()
{
Delay_ms(500);
}
//****************************************************************************
void Delay1000ms()
{
Delay_ms(1000);
}
//***************************************************************************
void main()
{
long int num;
unsigned char i, j, k, n, head, headfunc, previous, code, z;

const delay = 1000;
            //  76543210
	ANSEL =   0b00000000;
	PORTA =   0b00000000;      //  Start with Everything Low
	PORTC =   0b00000000;			 //  Start with Everything Low
	CMCON0 =  0b00000111;  		 //  Set all Comparators Off
	OSCCON =  0b01110001;			 //  Clock Frequency Set @ 8Mhz
  TRISA =   0b00000001;      //  Bit 1 is IR Detector
	TRISC =   0b00000000;			 //
  num = 1;
  head = 0;
//****************************************************************************
// Initialize Serial LCD Display
//****************************************************************************
  for (i = 0; i < 3; i++)
      {
      Delay10ms();
    	Nybble(3, 0);          	//  Init LCD
    	}
    	Nybble(2, 0);          	//  Set LCD 4 Bit Mode
      Delay10ms();
		sResetLCD();					   //  Call Reset LCD
		  Delay500ms();
		sDString(Message1, sLCD_FIRST_ROW);		 //  Displays Message on Row 1
		sDString(Message2, sLCD_SECOND_ROW);		 //  Displays Message on Row 2
		Delay1000ms();
		Delay1000ms();
		sLCD_Cmd(sLCD_CURSOR_OFF);
		sResetLCD();
//************************************************************************
while (1==1)								//  Loop Here
	{
    Byte2Binary(sLCD_THIRD_ROW, 1, PORTC, output);
    sDString(Message19, sLCD_FIRST_ROW);
		sLCD_Cmd(sLCD_SECOND_ROW);
		sony_cmd = sony_rx_run(code);

    if (sony_cmd == 21)
       {
        head = head ^ 1;
        Delay_ms(500);
       }
    if (head == 1)
        {
        headfunc = 0b100000;
        n = sony_cmd + 10;   // Adds 10 to IR Command for Head Functions
        }
    else
        {
        headfunc = 0b000000;  // Responds to IR Commands for Motor Functions
        n = sony_cmd;
        }
        sMove_Cursor(sLCD_SECOND_ROW, 1);
        sLCDtoBCD(n, 3);        // Displays Decimal Equiv of Each Button
        sDString(Message20, sLCD_FOURTH_ROW);
switch(n)
		     {
//***************************************************************************
		case 121:  // Forward Motor
		      //  76543210
    PORTC = 0b001111;
    PORTA.F1 = 1;
    sDString(Message3, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
    case 124:  // Forw Right
    		  //  76543210
    PORTC = 0b001101;
    PORTA.F1 = 1;
    sDString(Message5, sLCD_FOURTH_ROW);
    Delay500ms();
    break;
//***************************************************************************
		case 123:  // Forw Left
				  //  76543210
    PORTC = 0b001110;
    PORTA.F1 = 1;
    sDString(Message4, sLCD_FOURTH_ROW);
    Delay500ms();
    break;
//***************************************************************************
		case 122:  // Reverse Motor
				  //  76543210
    PORTC = 0b011111;
    PORTA.F1 = 1;
    sDString(Message18, sLCD_FOURTH_ROW);
    Delay500ms();
    break;
//***************************************************************************
		case 11:   // Stop
				  //  76543210
    PORTC = 0b000000;
    PORTA.F1 = 0;
    sDString(Message21, sLCD_FOURTH_ROW);
    Delay500ms();
    break;
//***************************************************************************
    case 21:   // Stop
				  //  76543210
    PORTC = 0b000000;
    PORTA.F1 = 0;
    sDString(Message21, sLCD_FOURTH_ROW);
    Delay500ms();
    break;
//***************************************************************************
		case 133:  // Head Left
		      //  76543210
    PORTC = 0b011110 + headfunc;
    PORTA.F1 = 1;
    sDString(Message7, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 134:  // Head Right
		      //  76543210
    PORTC = 0b011101 + headfunc;
    PORTA.F1 = 1;
    sDString(Message6, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 131:  // Arm Raise     28
		      //  76543210
    PORTC = 0b010101 + headfunc;
    PORTA.F1 = 1;
    sDString(Message8, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 132:  // Arm Lower     29
		      //  76543210
    PORTC = 0b010110 + headfunc;
    PORTA.F1 = 1;
    sDString(Message9, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 59:  // Arm Extend
		      //  76543210
    PORTC = 0b011001 + headfunc;
    PORTA.F1 = 1;
    sDString(Message10, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 58:  // Arm Retract
		      //  76543210
    PORTC = 0b011010 + headfunc;
    PORTA.F1 = 1;
    sDString(Message11, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 13:  // Grip Open
		      //  76543210
    PORTC = 0b001110 + headfunc;
    PORTA.F1 = 1;
    sDString(Message12, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 15:  //  Grip Close
		      //  76543210
    PORTC = 0b001101 + headfunc;
    PORTA.F1 = 1;
    sDString(Message13, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 14:  // Wrist Pivot Left
		      //  76543210
    PORTC = 0b000110 + headfunc;
    PORTA.F1 = 1;
    sDString(Message14, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 12:  //  Wrist Pivot Right
		      //  76543210
    PORTC = 0b000101 + headfunc;
    PORTA.F1 = 1;
    sDString(Message15, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 16:  // Wrist Rotate Left
		      //  76543210
    PORTC = 0b001010 + headfunc;
    PORTA.F1 = 1;
    sDString(Message16, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
		case 18:  //  Wrist Rotate Right
		      //  76543210
    PORTC = 0b001001 + headfunc;
    PORTA.F1 = 1;
    sDString(Message17, sLCD_FOURTH_ROW);
    Delay500ms();
		break;
//***************************************************************************
   default:
   z = 0;

        } // End Switch
	} //  End While
}  //  End MessageP16F688
//*************************************************************************
